package org.example.music.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.example.music.common.R;
import org.example.music.model.request.AdminRequest;
import org.example.music.service.AdminService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpSession;

/**
 * 后台管理的相关事宜
 */
@Api(value = "AdminController", tags = {"登录控制类"})
@RestController
public class AdminController {
    @Autowired
    private AdminService adminService;

    // 判断是否登录成功
    @ApiOperation(value = "登录校验")
    @PostMapping("/admin/login/status")
    public R loginStatus(@RequestBody AdminRequest adminRequest, HttpSession session) {
        return adminService.verityPasswd(adminRequest, session);
    }
}
