package org.example.music.controller;

import org.example.music.common.R;
import org.example.music.model.request.CollectRequest;
import org.example.music.service.CollectService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@Api(value = "CollectController", tags = {"歌曲收藏控制类"})
@RestController
public class CollectController {

    @Autowired
    private CollectService collectService;

    // 添加收藏的歌曲
    //前台界面逻辑
    @ApiOperation(value = "添加收藏歌曲")
    @PostMapping("/collection/add")
    public R addCollection(@RequestBody CollectRequest addCollectRequest) {
        return collectService.addCollection(addCollectRequest);
    }

    //TODO  这些其实有点偏简单的逻辑  所以就一点 所以放在外面  拿到里面
    // 取消收藏的歌曲
    @ApiOperation(value = "取消收藏歌曲")
    @DeleteMapping("/collection/delete")
    public R deleteCollection(@RequestParam Integer userId, @RequestParam Integer songId) {
        return collectService.deleteCollect(userId, songId);
    }

    // 是否收藏歌曲
    @ApiOperation(value = "判断是否已经收藏歌曲")
    @PostMapping("/collection/status")
    public R isCollection(@RequestBody CollectRequest isCollectRequest) {
        return collectService.existSongId(isCollectRequest);

    }

    // 返回的指定用户 ID 收藏的列表
    @ApiOperation(value = "查询收藏列表")
    @GetMapping("/collection/detail")
    public R collectionOfUser(@RequestParam Integer userId) {
        return collectService.collectionOfUser(userId);
    }
}
