package org.example.music.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.example.music.common.R;
import org.example.music.model.request.CommentRequest;
import org.example.music.service.CommentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@Api(value = "CommentController", tags = {"评论控制类"})
@RestController
public class CommentController {
    @Autowired
    private CommentService commentService;

    // 提交评论
    @ApiOperation(value = "新增评论")
    @PostMapping("/comment/add")
    public R addComment(@RequestBody CommentRequest addCommentRequest) {
        return commentService.addComment(addCommentRequest);
    }

    // 删除评论
    @ApiOperation(value = "删除评论")
    @GetMapping("/comment/delete")
    public R deleteComment(@RequestParam Integer id) {
        return commentService.deleteComment(id);
    }

    // 获得指定歌曲 ID 的评论列表
    @ApiOperation(value = "获取指定歌曲的评论列表")
    @GetMapping("/comment/song/detail")
    public R commentOfSongId(@RequestParam Integer songId) {
        return commentService.commentOfSongId(songId);
    }

    // 获得指定歌单 ID 的评论列表
    @ApiOperation(value = "获取指定歌单的评论列表")
    @GetMapping("/comment/songList/detail")
    public R commentOfSongListId(@RequestParam Integer songListId) {
        return commentService.commentOfSongListId(songListId);
    }

    // 点赞
    @ApiOperation(value = "点赞")
    @PostMapping("/comment/like")
    public R commentOfLike(@RequestBody CommentRequest upCommentRequest) {
        return commentService.updateCommentMsg(upCommentRequest);
    }
}
